#!/bin/bash

uuid=$(blkid|grep xfs|awk '{print $2}')
if [ "$uuid" = "" ]
then
 echo "no Hard disk found."
  exit
fi

wallet=$(cat /etc/spacemesh/wallet)
if [ "$wallet" = sm1qqqqqqxe4vzl0x3mnzt8g2q734k9ph72l3c2s4ct0rp6r ] || [ "$wallet" = "" ]
then
        echo "default wallet, exit"
	exit
fi


#spacemesh_version=$(grpcurl --plaintext 127.0.0.1:4092 spacemesh.v1.NodeService.Version|jq .versionString.value|awk -F'"' '{print $2}')
spacemesh_version=$(/root/Spacemesh/Linux/go-spacemesh version|awk -F+ '{print $1}')

n=1
lastaddr=""
while true
do
addr=$(cat /etc/spacemesh/server_addr|head -$n|tail -1)
if [ "$addr" != "$lastaddr" ]
then
        lastaddr=$addr;
else
        echo "no version getted"
        exit
fi
version_api_url="http://$addr/download/spacemesh/spacemesh_version"
res=$(curl -H 'Cache-Control: no-cache'  -s --connect-timeout 10 --max-time 10 $version_api_url)

version_latest=$(echo $res|jq .version|awk -F'"' '{print $2}')
checksum=$(echo $res|jq .checksum|awk -F'"' '{print $2}')
if [ "$version_latest" = "" ]
then
        n=`expr $n + 1`;
else
        break
fi

done

echo current version $spacemesh_version
echo new version: $version_latest, checksum : $checksum
grp_version=$(cat /etc/spacemesh/grpcurl_version)
grp_version_latest=$(echo $res|jq .grpcurl_version|awk -F'"' '{print $2}')
config_version=$(cat /etc/spacemesh/config_version)
config_version_latest=$(echo $res|jq .config_version|awk -F'"' '{print $2}')

echo  current grpcurl version $grp_version
echo  latest grpcurl version $grp_version_latest
echo  current config version $config_version
echo  latest config version $config_version_latest

if [ "$config_version" != "$config_version_latest" ]
then
	cd /root/Spacemesh
        echo "find new config version $grp_version_latest"
        rm -rf config-mainnet-*
        wget "http://$addr/download/spacemesh/config-mainnet-"$config_version_latest".json"
        caledchecksum=$(sha256sum config-mainnet-"$config_version_latest".json|awk '{print $1}')
        config_checksum=$(echo $res|jq .config_checksum|awk -F'"' '{print $2}')
        if [ "$config_checksum" = "$caledchecksum" ]
        then
                mv config-mainnet-"$config_version_latest".json networks.json
                sync
                echo $config_version_latest > /etc/spacemesh/config_version
                sync
		systemctl stop spacemesh
		sleep 2
		systemctl restart spacemesh
        else
                echo "error config checksum"
        fi
fi


if [ "$grp_version" != "$grp_version_latest" ]
then
	cd /root/Spacemesh
	echo "find new grpcurl version $grp_version_latest"
	rm -rf grpcurl_*.tar.gz
	wget "http://$addr/download/spacemesh/grpcurl_"$grp_version_latest"_linux_x86_64.tar.gz"
	caledchecksum=$(sha256sum grpcurl_"$grp_version_latest"_linux_x86_64.tar.gz|awk '{print $1}')
	grp_checksum=$(echo $res|jq .grpcurl_checksum|awk -F'"' '{print $2}')
	if [ "$grp_checksum" = "$caledchecksum" ]
	then
		tar -zxvf grpcurl_"$grp_version_latest"_linux_x86_64.tar.gz
		mv grpcurl /bin/
		sync
		echo $grp_version_latest > /etc/spacemesh/grpcurl_version
		sync
	else
		echo "error grpcurl checksum"
	fi
fi



if [ "$spacemesh_version" = "$version_latest" ]
then
	echo "spacemesh is newest"
	exit
fi
echo "find new version $version_latest"
cd /root/Spacemesh 
rm -rf Linux-*.zip
wget "http://$addr/download/spacemesh/Linux-$version_latest.zip"
caledchecksum=$(sha256sum Linux-$version_latest.zip|awk '{print $1}')

if [ "$checksum" != "$caledchecksum" ]
then
	echo "error checksum, exit"
	exit
fi

systemctl stop spacemesh
rm -rf Linux
unzip Linux-$version_latest.zip 
systemctl restart spacemesh

